# -*- coding: utf-8 -*-

# 2011-12-17 programmeerimisvõistlus
# Ülesanne: VENNK
# Autor: Karl-Aksel Puulmann
# Testitud: Python 2.7.2, Python 3.2.2

def main():
    def sygavuti_otsing(r, c, taide):
        if 0 <= r < korgus and 0 <= c < laius and diagramm[r][c] == '.':
            diagramm[r][c] = taide
            sygavuti_otsing(r-1, c, taide)
            sygavuti_otsing(r+1, c, taide)
            sygavuti_otsing(r, c-1, taide)
            sygavuti_otsing(r, c+1, taide)

    sisend = open('s3sis,txt')
    laius, korgus = [int(x) for x in sisend.readline().split()]
    diagramm = []
    for _ in range(korgus):
        diagramm.append(list(sisend.readline().strip()))

    ## Iga rea kohta vaatame ainult äärisest "välja jäävaid asju"
    ## Probleemi taustaga lahendame järgneval moodusel:
    ## alustada iga rea ja veeru algusest laiuti otsingut suvalise
    ## märgiga ja hiljem märgid tagasi asendada
    for r in range(korgus):
        sygavuti_otsing(r, 0, '+')
        sygavuti_otsing(r, laius-1, '+')
    for c in range(laius):
        sygavuti_otsing(0, c, '+')
        sygavuti_otsing(korgus-1, c, '+')
    mitmes = 0
    for r in range(korgus):
        for c in range(laius):
            if diagramm[r][c] == '.':
                sygavuti_otsing(r, c, chr(ord('A') + mitmes))
                mitmes += 1

    ## Taastame diagrammi,
    ## Teeme valjundi prinditavaks tekstiks ja väljastame faili
    valjund = '\n'.join(''.join(rida).replace('+','.') for rida in diagramm)
    open('s3val.txt','w').write(valjund)

main()
